#ifndef __MEM
#define __MEM

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef size_t
#define size_t unsigned long

#undef NULL
#define NULL ((void*)0)

#define memcpy _rom_call(void*,(void*,void*,long),26A)
#define memchr _rom_call(void*,(void*,short,long),273)
#define memmove _rom_call(void*,(void*,void*,long),26B)
#define memcmp _rom_call(short,(void*,void*,long),270)
#define memset _rom_call(void*,(void*,short,long),27C)
#define _memset _rom_call(void*,(void*,short,long),27B)

#ifdef DOORS

void *memcpy(void*,void*,long);
void *memchr(void*,short,long);
void *memmove(void*,void*,long);
short memcmp(void*,void*,long);
void *memset(void*,short,long);
void *_memset(void*,short,long);

#endif

#endif
